"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var JSRuleFinder_1 = require("./shared/JSRuleFinder");
var ES6Plugin = (function () {
    function ES6Plugin() {
    }
    ES6Plugin.prototype.configure = function (builder, spin) {
        if (builder.stack.hasAll(['es6', 'webpack']) &&
            (!builder.stack.hasAny('dll') || builder.stack.hasAny(['android', 'ios']))) {
            if (builder.stack.hasAny('es6') && !builder.stack.hasAny('dll')) {
                builder.config = spin.merge({
                    entry: {
                        index: ['babel-polyfill']
                    }
                }, builder.config);
            }
            var jsRuleFinder = new JSRuleFinder_1.default(builder);
            var jsRule = jsRuleFinder.findAndCreateJSRule();
            jsRule.exclude = /node_modules/;
            var _a = builder.babelConfig || { merge: {} }, merge = _a.merge, config = __rest(_a, ["merge"]);
            jsRule.use = {
                loader: builder.require.probe('heroku-babel-loader') ? 'heroku-babel-loader' : 'babel-loader',
                options: spin.mergeWithStrategy(merge, {
                    babelrc: false,
                    cacheDirectory: builder.cache === false || (builder.cache === 'auto' && !spin.dev)
                        ? false
                        : path.join(builder.cache === true || (builder.cache === 'auto' && spin.dev) ? '.cache' : builder.cache, 'babel-loader'),
                    compact: !spin.dev,
                    presets: [
                        'babel-preset-react',
                        ['babel-preset-env', { modules: false }],
                        'babel-preset-stage-0'
                    ].concat(spin.dev ? [] : [['babel-preset-minify', { mangle: false }]]),
                    plugins: [
                        'babel-plugin-transform-runtime',
                        'babel-plugin-transform-decorators-legacy',
                        'babel-plugin-transform-class-properties'
                    ],
                    only: jsRuleFinder.extensions.map(function (ext) { return '*.' + ext; })
                }, config)
            };
        }
    };
    return ES6Plugin;
}());
exports.default = ES6Plugin;
//# sourceMappingURL=ES6Plugin.js.map